# written by Anirban Bhattacharya
# do not share without permission



# Rue's sampler for MVN
# sample from N(Q^{-1}b, Q^{-1}) 
mvnrue = function(Q,b){ 
  d = length(b)
  L = t(chol(Q))                      # Q = LL'; R returns right Cholesky factor
  yr = solve(t(L),rnorm(d))           # z~N(0,I_d), L'y=z
  vr = solve(L,b)
  thetar = solve(t(L),vr)             # L'theta = v, where Lv = b
  samp = yr + thetar
  return(samp)
}

# log-prior distribution (upto constant) on global precision xi ...
# induced from Half-Cauchy prior on tau = xi^{-1/2}
# used for MH ratio calculation
lgpixi = function(xi){
  lgprior = -0.5*log(xi) - log(1+xi)
  return(lgprior)
}

# log-marginal likelihood of xi (upto constants)
lgmarglikxi = function(xi,A,B,a0,b0){
  # A = log|M|, where M = I_n + xi^(-1) XX'
  # B = y'M^(-1)y
  lgmarglikxi = -0.5*A-0.5*(n+a0)*log(b0+B)
  return(lgmarglikxi)
}